{-# LANGUAGE ForeignFunctionInterface, TypeFamilies, MultiParamTypeClasses, 
             FlexibleInstances, TypeSynonymInstances, EmptyDataDecls, 
             OverlappingInstances, IncoherentInstances #-}

module HROOT.IO.TFile.Implementation where


import FFICXX.Runtime.Cast

import HROOT.IO.TFile.RawType
import HROOT.IO.TFile.FFI
import HROOT.IO.TFile.Interface
import HROOT.IO.TFile.Cast
import HROOT.Core.TKey.RawType
import HROOT.Core.TKey.Cast
import HROOT.Core.TKey.Interface
import HROOT.Core.TClass.RawType
import HROOT.Core.TClass.Cast
import HROOT.Core.TClass.Interface
import HROOT.IO.TDirectoryFile.RawType
import HROOT.IO.TDirectoryFile.Cast
import HROOT.IO.TDirectoryFile.Interface
import HROOT.Core.TDirectory.RawType
import HROOT.Core.TDirectory.Cast
import HROOT.Core.TDirectory.Interface
import HROOT.Core.TNamed.RawType
import HROOT.Core.TNamed.Cast
import HROOT.Core.TNamed.Interface
import HROOT.Core.TObject.RawType
import HROOT.Core.TObject.Cast
import HROOT.Core.TObject.Interface
import HROOT.Core.Deletable.RawType
import HROOT.Core.Deletable.Cast
import HROOT.Core.Deletable.Interface

import Data.Word
import Foreign.C
import Foreign.Ptr 
import Foreign.ForeignPtr

import System.IO.Unsafe


instance ITFile TFile where
instance ITDirectoryFile TFile where
instance ITDirectory TFile where
  append = xform2 c_tfile_append
  addD = xform2 c_tfile_addd
  appendKey = xform1 c_tfile_appendkey
  close = xform1 c_tfile_close
  get = xform1 c_tfile_get
  cd_TDirectory = xform1 c_tfile_cd_tdirectory
instance ITNamed TFile where
  setName = xform1 c_tfile_setname
  setNameTitle = xform2 c_tfile_setnametitle
  setTitle = xform1 c_tfile_settitle
instance ITObject TFile where
  draw = xform1 c_tfile_draw
  findObject = xform1 c_tfile_findobject
  getName = xform0 c_tfile_getname
  isA = xform0 c_tfile_isa
  paint = xform1 c_tfile_paint
  printObj = xform1 c_tfile_printobj
  saveAs = xform2 c_tfile_saveas
  write = xform3 c_tfile_write
instance IDeletable TFile where
  delete = xform0 c_tfile_delete

instance ITFile (Exist TFile) where

instance ITDirectoryFile (Exist TFile) where

instance ITDirectory (Exist TFile) where
  append (ETFile x) = append x
  addD (ETFile x) = addD x
  appendKey (ETFile x) = appendKey x
  close (ETFile x) = close x
  get (ETFile x) = get x
  cd_TDirectory (ETFile x) = cd_TDirectory x
instance ITNamed (Exist TFile) where
  setName (ETFile x) = setName x
  setNameTitle (ETFile x) = setNameTitle x
  setTitle (ETFile x) = setTitle x
instance ITObject (Exist TFile) where
  draw (ETFile x) = draw x
  findObject (ETFile x) = findObject x
  getName (ETFile x) = getName x
  isA (ETFile x) = isA x
  paint (ETFile x) = paint x
  printObj (ETFile x) = printObj x
  saveAs (ETFile x) = saveAs x
  write (ETFile x) = write x
instance IDeletable (Exist TFile) where
  delete (ETFile x) = delete x


newTFile :: CString -> CString -> CString -> CInt -> IO TFile
newTFile = xform3 c_tfile_newtfile





instance FPtr (Exist TFile) where
  type Raw (Exist TFile) = RawTFile
  get_fptr (ETFile obj) = castForeignPtr (get_fptr obj)
  cast_fptr_to_obj fptr = ETFile (cast_fptr_to_obj (fptr :: ForeignPtr RawTFile) :: TFile)
